﻿
Public Class Form1

    Private FileName As String
    Private ds As New DataSet()

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        OpenFileDialog1.Filter = "csv files|;*.csv"
        OpenFileDialog1.Title = "Select a csv file"
        OpenFileDialog1.FileName = ""

        Try
            With OpenFileDialog1
                If .ShowDialog() = DialogResult.OK Then
                    FileName = .FileName
                    TextBox1.Text = FileName

                    Dim myData As DataTable = TworzTabele(FileName) ' inicjacja nowej tabeli i wypełnienie jej funkcją
                    ds.Tables.Add(myData) ' wypełnienie bazy danych informacjami z tabeli
                    DataGridView1.DataSource = myData ' wyświetlenie tabeli w DatagridView
                End If

            End With
        Catch
        End Try
    End Sub

    Private Function TworzTabele(ByVal SciezkaDoPliku As String) As DataTable

        Dim Tabela As DataTable = New DataTable("MyTable")
        Dim i As Integer
        Dim wiersze As DataRow
        Dim wartosc As String()
        Dim f As IO.File = Nothing
        Dim rodzajkodu As New IO.StreamReader(SciezkaDoPliku, System.Text.Encoding.UTF8)

        Try
            wartosc = rodzajkodu.ReadLine().Split(ControlChars.Tab)

            For i = 0 To wartosc.Length() - 1
                Tabela.Columns.Add(New DataColumn("Field" & i))
            Next

            wiersze = Tabela.NewRow  ' dodaje nowy wiersz
            For i = 0 To wartosc.Length() - 1
                wiersze.Item(i) = wartosc(i).ToString ' dodaje informacje do komurek
            Next

            Tabela.Rows.Add(wiersze) ' wypełnia tabele

            While rodzajkodu.Peek() <> -1
                wartosc = rodzajkodu.ReadLine().Split(ControlChars.Tab)
                wiersze = Tabela.NewRow
                For i = 0 To wartosc.Length() - 1
                    wiersze.Item(i) = wartosc(i).ToString
                Next
                Tabela.Rows.Add(wiersze)
            End While
        Catch ex As Exception
            MsgBox("Error building datatable: " & ex.Message)
            Return New DataTable("Empty")
        Finally
            rodzajkodu.Close()
        End Try

        Return Tabela
    End Function

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Dim sfd As New SaveFileDialog
        With sfd
            .FileName = "nowa"
            .Filter = "Text File|*.csv"
        End With
        If sfd.ShowDialog = Windows.Forms.DialogResult.OK Then
            Call data_to_txt(ds.Tables("MyTable"), sfd.FileName)
        End If
    End Sub

    Private Sub data_to_txt(ByVal dt As DataTable, ByVal filename As String)
        Dim sw As New IO.StreamWriter(filename, False)
        If dt.Columns.Count < 0 OrElse dt.Rows.Count < 0 Then 'Pętla na wypadek przedwczesnego przyciśnięcia eksportu
            MsgBox("Nie zostało nic zaimportowane")
            Exit Sub
        End If
        For row As Integer = 0 To dt.Rows.Count - 1
            For col As Integer = 0 To dt.Columns.Count - 1

                sw.Write(dt.Rows(row).Item(col).ToString & ControlChars.Tab)
            Next
            sw.Write(Environment.NewLine)
        Next
        sw.Close()
    End Sub

    Private Sub LinkLabel1_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel1.LinkClicked
        Process.Start("http://visualmonsters.cba.pl")
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'TODO: Ten wiersz kodu wczytuje dane do tabeli 'DbDataSet.Table' . Możesz go przenieść lub usunąć.
        Me.TableTableAdapter.Fill(Me.DbDataSet.Table)
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        If DataGridView1.Rows.Count > 0 Then
            For i As Integer = 0 To DataGridView1.Rows.Count - 1
                'dla każdego wiersza w podglądzie
                'tworzymy zmienne
                'takie jak w tabeli
                Dim nr_pr As String = DataGridView1.Rows(i).Cells(0).Value
                Dim data As String = DataGridView1.Rows(i).Cells(1).Value
                Dim p1 As Boolean = DataGridView1.Rows(i).Cells(2).Value
                Dim p2 As Boolean = DataGridView1.Rows(i).Cells(3).Value
                Dim p3 As Boolean = DataGridView1.Rows(i).Cells(4).Value
                Dim p4 As Boolean = DataGridView1.Rows(i).Cells(5).Value
                'dodajemy wiersz do BindingSource
                Dim row = DirectCast(TableBindingSource.AddNew(), DataRowView)
                Try
                    'przypisujemy mu wartości
                    row.Item(1) = nr_pr
                    row.Item(2) = data
                    row.Item(3) = p1
                    row.Item(4) = p2
                    row.Item(5) = p3
                    row.Item(6) = p4
                    'kończymy edycje, jeśli coś poszlo nie tak to właśnie tutaj
                    TableBindingSource.EndEdit()
                    DataGridView1.Rows(i).Cells(0).Style.BackColor = Color.GreenYellow
                Catch ex As Exception
                    'usuwamy wiersz nad którym pracowaliśmy
                    TableBindingSource.RemoveCurrent()
                    'jeśli operacja się nie udała, bo np. druga kolumna ma więcej znaków niż przeznaczyliśmy na nie w tabeli
                    'wtedy zapali się na czerwono
                    'np data ma nchart(19), jesli pobrane dane będą miały 20 wtedy nie uda się dodać danych
                    DataGridView1.Rows(i).Cells(0).Style.BackColor = Color.Tomato
                End Try
            Next
            'jak już zaktualizujemy BindingSource wtedy wszystko zapisujemy
            TableTableAdapter.Update(Me.DbDataSet.Table)
        End If
    End Sub

End Class
